FC v. 3.03 (c) 2004 Maurizio Spagni

FC compara dos archivos, o conjuntos de archivos, tanto en modo texto como en
modo binario; y muestra las diferencias entre ellos.

FC es una implementacin del algoritmo de Paul Heckel del nmero de abril de
1978 de Communications of the Association for Computing Machinery,
pginas 264-268, A Technique for Isolating Differences Between Files.

Las ventajas de este algoritmo son su velocidad y que puede detectar las
diferencias de cualquier nmero de lneas. Para la mayora de las aplicaciones,
el algoritmo asla diferencias similares a las aisladas por la subsecuencia
comn ms larga.

Sintaxis:

FC [opciones] [unidad1:][ruta1]archivo1 [unidad2][ruta2]archivo2 [opciones]

 /A    Muestra solo la primera y ltima lnea para cada conjunto de diferencias
 /B    Comparacin binaria
 /C    No diferenciar maysculas de minsculas
 /L    Comparar texto ASCII
 /LBn  n son las mximas lneas ASCII consecutivas
 /Mn   n son las mximas diferencias en la comparacin binaria
 /N    Mostar nmeros de lnea al comparar textos
 /Q    No mostrar diferencias
 /R    Muestra un resumen al final
 /S    Procesar tambin los archivos en subcarpetas. Implica /R
 /T    No convertir caracteres tabuladores en espacios
 /U    Mostrar los nombres de los archivos sin correspondencias
 /W    Comprimir espacios en blanco (sangras y espacios) al comparar texto
 /X    No mostrar contexto al comparar texto
 /nnn  nnn son las lneas iguales mnimas a mostrar para resincronizar la
 comparacin

El programa es compatible con nombres largos, y los usar automaticamente si el
sistema operativo lo permite.

Por omisin FC entra en modo binario con las extensiones .EXE, .COM, .SYS, .OBJ,
.BIN, .DLL y .LIB.

En modo binario FC muestra el desplazamiento entre los octetos no coincidentes,
su valor hexadecimal y, si se puede, imprime el caracter ASCII correspondiente.

Por omisin la comparacin binaria termina tras 20 diferencias, pero esto puede
cambiarse con la opcin /M. /M0 y /M indican todas las diferencias.

Un problema de diseo de este programa es que, en modo texto, solo compara las
primeras 32765 lneas; el resto son ignoradas. No hai lmite en la longitud de
cada lnea.

Apuntes sobre usar comodines en los archivos:
- Indicar una carpeta es lo mismo que indicar todos los archivos de esa carpeta
  (*.*).
  Por ejemplo: FC C:\ A: es equivalente a FC C:\*.* A:*.*
- Si no hay archivo2 se asume la carpeta actual-
  Por ejemplo: FC C:\NOTA.TXT es lo mismo que FC C:\NOTA.TXT *.*
- Si archivo1 tiene comodines, pero archivo2 no, todos los archivos que
  coincidan con archivo1 se comparan con archivo2.
  Por ejemplo: FC FOO.BK? FOO.TXT
               Todos los archivos que coincidan con FOO.BK? se comparan con
               FOO.TXT
- Si archivo1 tiene comodines y archivo2 es una ruta seguida de *.* entonces
  todos los archivos que coincidan con archivo1 se comparan con aquellos
  archivos de la ruta de archivo2 cuyo nombre coincida (si existen, claro).
  Por ejemplo: FC *.* A:*.*, o ms corto FC . A:
               Todos los ficheros en la carpeta actual se comparan con su
               copia en A:
- Si archivo1 y archivo2 tienen comodines entonces todos los archivos de
  archivo1 se comparan con el archivo en archivo2 que le correspondiere a cada
  uno. (si existieren, claro).
  Por ejemplo: FC *.TXT COPIAS\*.BAK
               Todos los archivos en la carpeta actual se comparan con su copia
               de seguridad con la extensin BAK guardada en la carpeta COPIAS.
Pero del dicho al hecho hay un trecho.
Si en verdad quiere comparar cada archivo de una carpeta con todos los archivos
de otra puede usar:
FC *.* CARPETA\????????.???

La opcin /S reusa el mismo patrn al buscar en cada subcarpeta cuyo nombre en
cada lado coincida.
  Por ejemplo: FD /S C:*.TXT D:*.BAK
               Si hay una carpeta llamada LIBROS tanto en C: como en D: esto
               compara todos los archivos que coincidan con *.TXT con sus copias
               *.BAK en la carpeta actual, y todos los archivos LIBROS\*.TXT con
               sus copias en LIBROS\*.BAK.

Al salir los valores en ERRORLEVEL pueden ser los siguientes:
	0	Todos los archivos coinciden
	1	Difieren como mnimo un par de archivos
	2	Parmetro invlido
	3	Archivo no encontrado
	4	No se pudieron abrir el archivo o archivos
